// Type definitions for gl-vec2 1.3
// Project: https://github.com/stackgl/gl-vec2
// Definitions by:  Adam Zerella <https://github.com/adamzerella>
// Definitions: https://github.com/DefinitelyTyped/DefinitelyTyped
// TypeScript Version: 3.3

import add = require('./add');
import clone = require('./clone');
import copy = require('./copy');
import create = require('./create');
import cross = require('./cross');
import dist = require('./dist');
import div = require('./div');
import dot = require('./dot');
import equals = require('./equals');
import exactEquals = require('./exactEquals');
import floor = require('./floor');
import forEach = require('./forEach');
import fromValues = require('./fromValues');
import inverse = require('./inverse');
import len = require('./len');
import lerp = require('./lerp');
import limit = require('./limit');
import max = require('./max');
import min = require('./min');
import mul = require('./mul');
import negate = require('./negate');
import normalize = require('./normalize');
import random = require('./random');
import scale = require('./scale');
import scaleAndAdd = require('./scaleAndAdd');
import set = require('./set');
import sqrDist = require('./sqrDist');
import sqrLen = require('./sqrLen');
import sub = require('./sub');
import transformMat2 = require('./transformMat2');
import transformMat2d = require('./transformMat2d');
import transformMat3 = require('./transformMat3');
import transformMat4 = require('./transformMat4');

export {
    add,
    clone,
    copy,
    create,
    cross,
    dist,
    div,
    dot,
    equals,
    exactEquals,
    floor,
    forEach,
    fromValues,
    inverse,
    len,
    lerp,
    limit,
    max,
    min,
    mul,
    negate,
    normalize,
    random,
    scale,
    scaleAndAdd,
    set,
    sqrDist,
    sqrLen,
    sub,
    transformMat2,
    transformMat2d,
    transformMat3,
    transformMat4
};
